module top(){
    difference(){
        minkowski(){
            translate([0, 0, 25/2+5/2]) cube([(4*110+2*10)-5, 60-5, 25], center=true);
            sphere(d=5, $fn=30);
        }
        
        //Half
        translate([0, 0, 25+10/2]) cube([500, 60, 10], center=true);
        
        //Inner
        translate([0, 0, 25-5/2]) cube([(4*110+2*10)-5, 60-5, 5], center=true);
        
        //translate([0, 0, 10+5/2]) cube([70, 10, 5], center=true);
              
        
        for(dx=[-1.5:1:1.5], dy=[-0.5, 0.5]){
            translate([dx*110, dy*25, 0]){
                
                //Screws
                for(dxs = [-1, 1]){
                    translate([dxs*16, 0, 0]) screw();     
                }                  
                //Cables
                translate([0, 0, 12.5]) cube([100.25, 21, 5], center=true);                 
                translate([0, 0, 15]) cube([110, 15, 10], center=true);                 
                
                //Heat sink
                translate([0, 0, 25-10/2]) cube([100.25, 25.25, 13], center=true);  
                
                
                //Led holes                
                for(dxs = [-1, 0, 1]){
                    translate([dxs*32, 0, 0]) cylinder(d=18, h=1, center=false, $fn=30);
                    translate([dxs*32, 0, 1]) cylinder(d=20.35, h=14, center=false, $fn=30);          
                } 
            
            }
        }

        for(dx=[-2:1:2], dy=[-1, 0, 1]){
            translate([dx*110, dy*24, 10]) cylinder(d=2.9, h=20, center=false, $fn=30);
        }      
      
        for(dx=[-1, 1], dy=[-1, 0, 1]){
            translate([dx*55, dy*26, 8]) cube([20, 2.5, 8], center=true);
        }   
 
    }
}

module clip(){
    for(dx=[-1, 1], dy=[-1, 0, 1]){
        translate([dx*55, dy*26, 8]) cube([18, 2.5-0.5, 8-0.5], center=true);
    }   
}


module screw(){ 
    cylinder(d=6.25, h=2, center=false, $fn=15);
    translate([0, 0, 2.25]) cylinder(d=3.5, h=16, center=false, $fn=15);
}

module part1(){
    intersection(){
        top();
        cube([110, 70, 50], center=true);
    }
}

module part2(){
    intersection(){
        top();
        translate([-250/2-55, 0, 0]) cube([250, 70, 50], center=true);
    }
}

module test(){
    intersection(){
        top();
        translate([-250/2-111.5, -40/2+2, 0]) cube([250, 40, 50], center=true);
    }
}


module circuit(){
    difference(){
        translate([0, 0, (19+2+2*3)/2]) 
        difference(){
            minkowski(){
                cube([120-2, 90-2, 19+2], center=true);
                sphere(r=3, $fn=30);
            }
            minkowski(){
                cube([120-2*2, 90-2*2, 19], center=true);
                sphere(r=2, $fn=30);
            }
            
            translate([0, 0, 14.5]) cube([120+2*3, 90+2*3, 10], center=true);
        }
        
        
        for(dy=[-1, 0, 1]){
            translate([0, dy*24, 0]) cylinder(d=3.3, h=20, center=false, $fn=30);
        }  
        
        for(dx=[-1,1], dy=[1]){
            translate([dx*105/2, dy*24, 0]) cylinder(d=3.3, h=20, center=false, $fn=30);
        } 
        
        for(dy=[-0.5, 0.5]){
            translate([0, dy*25, 0])  cube([6, 15, 10], center=true);
        }  
        
        for(dx=[-1, 1], dy=[-5:1:5]){
            translate([dx*110/4, dy*6, 0])  cube([20, 3, 10], center=true);
        }  
        
        translate([55, 0, 13]) rotate([0, 90, 0]) cylinder(d=12.75, h=20, center=true, $fn=30);
    }

    for(dx=[-1, 1], dy=[-1, 1]){
    translate([dx*93/2, dy*64.75/2+7, 2])
        difference(){
            cylinder(d=5, h=4, center=false, $fn=30);
            cylinder(d=2.5, h=4, center=false, $fn=30);
        }
    }    
    
    for(dx=[-1, 1], dy=[-1, 1]){
        translate([dx*115/2, dy*85/2, 18/2+2])
        difference(){
            minkowski(){
                cube([4, 4, 18], center=true);
                cylinder(r=1, h=0.01, $fn=30);
            }
            translate([0, 0, 4]) cylinder(d=3, h=6, center=false, $fn=30);
        }
    }    
    
}

module spacer(){
    difference(){
        translate([0, 0, 20/2]) cube([9.5, 54.5, 20], center=true);
        for(dy=[-1,0,1]) translate([0, dy*25, 5/2]) cube([9.5, 10.5, 5], center=true);
        for(dy=[-0.5,0.5]) translate([0, dy*25, 20/2]) cube([7.5, 9.5, 20], center=true);
        for(dy=[-1,0,1]) translate([0, dy*24, 0]) cylinder(d=3.5, h=20, center=false, $fn=30);
   }
}

module foot(){
    difference(){
        translate([0, 0, 10/2]) cube([9.5, 54.5, 10], center=true);
        for(dy=[-1,0,1]) translate([0, dy*25, 5/2]) cube([9.5, 10.5, 5], center=true);
        //for(dy=[-0.5,0.5]) translate([0, dy*25, 20/2]) cube([7.5, 9.5, 20], center=true);
        translate([0, 0, 0]) cylinder(d=3.5, h=20, center=false, $fn=30);
   }
   for(dy=[-1,1])
   hull(){
    translate([0, dy*(54.5-20)/2, 10+0.25/2]) cube([9.5, 20, 0.25], center=true);
    translate([(9.5-2)/2, dy*30, 100]) cube([2, 10.5, 0.25], center=true);
   }
}


//translate([0, 0, 35]) circuit();
//translate([0, 0, 15]) spacer();
//part1();
//part2();
//foot();
top();


//bottom();
